/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.records.TCorePublicRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCorePublic extends TableImpl<TCorePublicRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_public</code>
     */
    public static final TCorePublic T_CORE_PUBLIC = new TCorePublic();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCorePublicRecord> getRecordType() {
        return TCorePublicRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_public.pk_core_public</code>.
     */
    public final TableField<TCorePublicRecord, Integer> PK_CORE_PUBLIC = createField(DSL.name("pk_core_public"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_public.public_value</code>. unique id
     */
    public final TableField<TCorePublicRecord, Integer> PUBLIC_VALUE = createField(DSL.name("public_value"), SQLDataType.INTEGER.nullable(false), this, "unique id");

    /**
     * The column <code>common_dd.t_core_public.public_lang</code>. language key
     */
    public final TableField<TCorePublicRecord, String> PUBLIC_LANG = createField(DSL.name("public_lang"), SQLDataType.CLOB.nullable(false), this, "language key");

    /**
     * The column <code>common_dd.t_core_public.lastchange</code>.
     */
    public final TableField<TCorePublicRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    private TCorePublic(Name alias, Table<TCorePublicRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCorePublic(Name alias, Table<TCorePublicRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_public</code> table reference
     */
    public TCorePublic(String alias) {
        this(DSL.name(alias), T_CORE_PUBLIC);
    }

    /**
     * Create an aliased <code>common_dd.t_core_public</code> table reference
     */
    public TCorePublic(Name alias) {
        this(alias, T_CORE_PUBLIC);
    }

    /**
     * Create a <code>common_dd.t_core_public</code> table reference
     */
    public TCorePublic() {
        this(DSL.name("t_core_public"), null);
    }

    public <O extends Record> TCorePublic(Table<O> path, ForeignKey<O, TCorePublicRecord> childPath, InverseForeignKey<O, TCorePublicRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_PUBLIC);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCorePublicPath extends TCorePublic implements Path<TCorePublicRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCorePublicPath(Table<O> path, ForeignKey<O, TCorePublicRecord> childPath, InverseForeignKey<O, TCorePublicRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCorePublicPath(Name alias, Table<TCorePublicRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCorePublicPath as(String alias) {
            return new TCorePublicPath(DSL.name(alias), this);
        }

        @Override
        public TCorePublicPath as(Name alias) {
            return new TCorePublicPath(alias, this);
        }

        @Override
        public TCorePublicPath as(Table<?> alias) {
            return new TCorePublicPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCorePublicRecord, Integer> getIdentity() {
        return (Identity<TCorePublicRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCorePublicRecord> getPrimaryKey() {
        return Keys.PK_CORE_PUBLIC;
    }

    @Override
    public List<UniqueKey<TCorePublicRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_PUBLIC);
    }

    @Override
    public List<ForeignKey<TCorePublicRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_PUBLIC__FK_PUBLIC_LANG);
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_CORE_PUBLIC__FK_PUBLIC_LANG, null);

        return _tCoreTranslationKey;
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, null, Keys.T_CORE_ELEMENT_HIERARCHY__IS_PUBLIC.getInverseKey());

        return _tCoreElementHierarchy;
    }

    @Override
    public TCorePublic as(String alias) {
        return new TCorePublic(DSL.name(alias), this);
    }

    @Override
    public TCorePublic as(Name alias) {
        return new TCorePublic(alias, this);
    }

    @Override
    public TCorePublic as(Table<?> alias) {
        return new TCorePublic(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCorePublic rename(String name) {
        return new TCorePublic(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCorePublic rename(Name name) {
        return new TCorePublic(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCorePublic rename(Table<?> name) {
        return new TCorePublic(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePublic where(Condition condition) {
        return new TCorePublic(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePublic where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePublic where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePublic where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePublic where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePublic where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePublic where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePublic where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePublic whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePublic whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
